// Copyright (C) 1996 DIMACS Center, Rutgers, The State University of New Jersey
// Author(s): Jonathan Berry

// This software is copyrighted by the DIMACS Center at Rutgers, The State
// University of New Jersey.  IT IS PROVIDED AS IS, AND THE AUTHORS, DIMACS, AND
// RUTGERS, THE STATE UNIVERSITY OF NEW JERSEY  DISCLAIM
// ALL LIABILITY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
// DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE, ITS DOCUMENTATION, OR ANY
// DERIVATIVES THEREOF, EVEN IF THE AUTHORS HAVE BEEN ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.

// THE AUTHORS AND DISTRIBUTORS SPECIFICALLY DISCLAIM ANY WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.  THIS SOFTWARE
// IS PROVIDED ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE
// NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
// MODIFICATIONS.

// The authors hereby grant permission to use, copy, modify, distribute,
// and license this software and its documentation for any purpose, provided
// that existing copyright notices are retained in all copies and that this
// notice is included verbatim in any distributions. No written agreement,
// license, or royalty fee is required for any of the authorized uses.
// Modifications to this software may be copyrighted by their authors
// and need not follow the licensing terms described here, provided that
// the new terms are clearly indicated on the first page of each file where
// they apply.

// Last File Update: 31-Jul-1996
// 

#ifdef __GNUC__
//
//	This file is used to instantiate any template classes or objects
//	which are not handled by the auto-generation methods (see the
//	utilities "instantiate" and "genMethods")
//
//	Currently, the auto-generation mechanism doesn't handle multiple
//	template arguments (and may never).

#define DEFINE_TEMPLATE

#include <LINK/basic/BinaryHeap.h>
#include <LINK/basic/BinarySearchTree.h>
//#include <LINK/basic/DyArray.h>
//#include <LINK/basic/Location.h>
#include <LINK/basic/RedBlackTree.h>

#include <LINK/basic/Matrix.h>
#include <LINK/basic/Array.h>
#include <LINK/basic/MSet.h>
#include <LINK/basic/Deque.h>
#include <LINK/basic/Stack.h>
#include <LINK/basic/Queue.h>

#undef DEFINE_TEMPLATE

//*** Would like to have these generated by genMethods eventually
//*** more basic A<int> classes are instantiated automatically in linkTemplates
template class Array<int>;
template class SortedArray<int>;
template class MSetBase<int, SortedArray<int> >;


template class Dictionary<int,int>;
template class Dictionary<char,char>;
template class Dictionary<int,char>;
template class Dictionary<char,int>;

template class BinaryHeap<int,int>;
template class BinaryHeap<char,char>;
template class BinaryHeap<int,char>;
template class BinaryHeap<char,int>;

template class BinaryHeapNode<int,int>;
template class BinaryHeapNode<char,char>;
template class BinaryHeapNode<int,char>;
template class BinaryHeapNode<char,int>;

template class BinarySearchTreeNode<int,int>;
template class BinarySearchTreeNode<char,char>;
template class BinarySearchTreeNode<int,char>;
template class BinarySearchTreeNode<char,int>;

template class BinarySearchTree<int,int>;
template class BinarySearchTree<char,char>;
template class BinarySearchTree<int,char>;
template class BinarySearchTree<char,int>;

template class Deque<int>;
template class Queue<int>;
template class Stack<int>;
template ostream& operator<<(ostream&, const Deque<int>&);


template class RedBlackTreeNode<int,int>;
template class RedBlackTreeNode<int,char>;
template class RedBlackTreeNode<char,int>;
template class RedBlackTreeNode<char,char>;

template class RedBlackTree<int,int>;
template class RedBlackTree<int,char>;
template class RedBlackTree<char,int>;
template class RedBlackTree<char,char>;

template class Matrix<int>;
template class SymMatrix<int>;
template class AsymMatrix<int>;
template ostream& operator<<(ostream&, const Matrix<int>&);

template class Matrix<double>;
template class SymMatrix<double>;
template class AsymMatrix<double>;
template ostream& operator<<(ostream&, const Matrix<double>&);

typedef char *String;
template class ElementOps<String>;
int ElementOps<String>::compareItems(const String& e1, const String& e2)
{
	return strcmp(e1,e2);
}

#endif
